/* 📖 Bindery Controls v1.1.0 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.BinderyControls = factory());
}(this, (function () { 'use strict';

function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);

  return css;
}

// const p = 'bindery-';
const p = '📖-';

const prefix = str => `${p}${str}`;
const prefixClass = str => `.${prefix(str)}`;

const c = (str) => {
  if (str[0] === '.') {
    return prefixClass(str.substr(1));
  }
  return prefix(str);
};

___$insertStyle("@media screen{.📖-viewing .📖-controls{display:flex!important}}.📖-controls{font:16px/1.4 -apple-system,BlinkMacSystemFont,Roboto,sans-serif;display:none;flex-direction:row;align-items:start;position:fixed;top:0;left:0;right:0;z-index:1;margin:auto;color:var(--bindery-ui-text);padding:10px;overflow:hidden;transition:height .3s;-webkit-font-smoothing:antialiased}.📖-controls *{font:inherit;color:inherit;margin:0;padding:0;box-sizing:border-box}.📖-controls a{color:var(--bindery-ui-accent);text-decoration:none}.📖-row{position:relative;display:flex;flex-wrap:wrap;align-items:start;cursor:default;user-select:none}.📖-print-options{display:flex;opacity:0;max-width:0;overflow:hidden;transition:all .3s;flex-wrap:nowrap;transition-delay:.1s}.📖-view-print .📖-print-options{max-width:720px;margin-right:12px;opacity:1}.📖-in-progress .📖-print-options{opacity:0;display:none}.📖-controls .📖-print-options .📖-control{background-color:transparent}.📖-controls .📖-btn{-webkit-appearance:none;cursor:pointer;display:inline-block;margin-right:8px;text-decoration:none}.📖-controls .📖-btn:hover{background:rgba(0,0,0,.04)}.📖-controls .📖-btn:active{background:rgba(0,0,0,.08)}.📖-controls .📖-btn:last-child{margin-right:0}.📖-control{border-radius:32px;color:var(--bindery-ui-text);padding:8px 20px}.📖-controls .📖-btn-light{background:none;border:none}.📖-controls .📖-btn-main{background:var(--bindery-ui-accent);border-color:var(--bindery-ui-accent);color:#fff}.📖-controls .📖-btn-main:hover{background:var(--bindery-ui-accent);opacity:.7}.📖-controls .📖-btn-main:active{background:#000;opacity:1}.📖-view-row{margin-left:auto;margin-right:12px;transition:all .3s}.📖-in-progress .📖-view-row{opacity:0;pointer-events:none}.📖-debug .📖-view-row{display:none}.📖-btn-print{transition:all .3s}.📖-in-progress .📖-btn-print{opacity:0;pointer-events:none}.📖-controls .📖-select-wrap{padding-right:36px;transition:all .2s;white-space:nowrap;width:100%}.📖-controls .📖-select-wrap:after{content:\"\";position:absolute;right:18px;top:14px;border-bottom:1px solid currentColor;border-right:1px solid currentColor;padding:3px;transform:rotate(45deg)}.📖-controls .📖-select-wrap:active,.📖-controls .📖-select-wrap:hover{background-color:rgba(0,0,0,.04)}.📖-controls .📖-select-wrap.📖-hidden-select{max-width:0;padding-left:0;padding-right:0;border-left-width:0;border-right-width:0;color:transparent}.📖-select{position:absolute;top:0;left:0;opacity:0;-webkit-appearance:none;-moz-appearance:none;padding:8px 20px;color:#000;border:transparent;width:100%}@media screen and (max-width:720px){.📖-print-options{max-width:unset;max-height:0}.📖-view-print .📖-print-options{max-width:unset;max-height:240px;margin:0}.📖-root{transition:all .2s}.📖-view-print.📖-root{padding-top:120px}.📖-controls{height:60px}.📖-view-row{margin-left:auto}.📖-view-print .📖-controls{height:104px}.📖-print-options{top:54px;right:10px;position:fixed;margin:0}.📖-print-options .📖-row{margin:0}}.📖-view-print .📖-controls{background:var(--bindery-ui-bg);box-shadow:0 .5px 1px rgba(0,0,0,.14)}@media screen and (max-width:960px){.📖-controls{background:var(--bindery-ui-bg);box-shadow:0 .5px 1px rgba(0,0,0,.14)}.📖-root{padding-top:72px}}@media screen and (max-width:500px){.📖-view-print.📖-root{padding-top:190px}.📖-view-print .📖-controls{background:var(--bindery-ui-bg);height:180px}.📖-print-options{flex-direction:column;align-items:stretch;left:10px}.📖-hidden-select{display:none}}");

const isFunc = val => typeof val === 'function';
const h = (tagName, cls, attrs, children, text) => {
  const el = document.createElement(tagName);
  if (cls) el.className = cls;
  if (text) el.textContent = text;
  if (attrs) for (const k in attrs) {
    const v = attrs[k];
    if (isFunc(v)) el[k] = v;
    else el.setAttribute(k, v);
  }
  if (children) children.forEach(c => el.appendChild(c));
  return el;
};

const div = (cls, children, label) => h('div', cls, {}, children, label);
const button = (cls, attrs, label) => h('button', cls, attrs, [], label);
const select = (cls, attrs, children) => h('select', cls, attrs, children);
const option = (attrs, label) => h('option', null, attrs, [], label);

const row = children => div(c('row'), children);

const btnMain = (attrs, txt) => button(`${c('control')} ${c('btn')} ${c('btn-main')}`, attrs, txt);

const dropdown = (attrs, options) => {
  const selectVal = div(c('select-val'), [], 'Value');
  const selectEl = select(c('select'), attrs, options);
  const updateVal = () => {
    selectVal.textContent = selectEl.options[selectEl.selectedIndex].text;
  };
  selectEl.addEventListener('change', updateVal);
  updateVal();
  return div(`${c('select-wrap')} ${c('control')}`, [selectVal, selectEl]);
};

const supportsCustomPageSize = !!window.chrome && !!window.chrome.webstore;

class Controls {
  constructor(availableOptions, initialState, actions) {
    const { Mode, Paper, Layout, Marks } = availableOptions;

    let viewSelect;
    let marksSelect;

    const print = () => {
      actions.setMode(Mode.PRINT);

      const sel = viewSelect.querySelector('select');
      sel.value = Mode.PRINT;
      sel.dispatchEvent(new Event('change'));

      setTimeout(window.print, 10);
    };

    const printBtn = btnMain({ onclick: print }, 'Print');

    const paperSizes = (supportsCustomPageSize ? [
      option({ value: Paper.AUTO }, 'Auto'),
      option({ value: Paper.AUTO_BLEED }, 'Auto + Bleed'),
      option({ value: Paper.AUTO_MARKS }, 'Auto + Marks'),
      option({ value: Paper.LETTER_PORTRAIT }, 'Letter Portrait'),
      option({ value: Paper.LETTER_LANDSCAPE }, 'Letter Landscape'),
      option({ value: Paper.A4_PORTRAIT }, 'A4 Portrait'),
      option({ value: Paper.A4_LANDSCAPE }, 'A4 Landscape'),
    ] : [
      option({ value: Paper.LETTER_PORTRAIT, selected: true }, 'Default Page Size *'),
      option({ disabled: true }, 'Only Chrome supports custom page sizes. Set in your browser\'s print dialog instead.'),
    ]).map((opt) => {
      if (parseInt(opt.value, 10) === initialState.paper) { opt.selected = true; }
      return opt;
    });

    const updateSheetSizeNames = () => {
      if (!supportsCustomPageSize) return;
      const size = actions.getPageSize();
      const sizeName = `${size.width} × ${size.height}`;
      paperSizes[0].textContent = `${sizeName}`;
      paperSizes[1].textContent = `${sizeName} + Bleed`;
      paperSizes[2].textContent = `${sizeName} + Marks`;
    };
    updateSheetSizeNames();

    const updatePaper = (e) => {
      const newVal = parseInt(e.target.value, 10);
      actions.setPaper(newVal);
      if (newVal === Paper.AUTO || newVal === Paper.AUTO_BLEED) {
        marksSelect.classList.add(c('hidden-select'));
      } else {
        marksSelect.classList.remove(c('hidden-select'));
      }
    };

    const sheetSizeSelect = dropdown({ onchange: updatePaper }, paperSizes);

    const layoutSelect = dropdown(
      { onchange: (e) => {
        actions.setLayout(e.target.value);
        updateSheetSizeNames();
      } },
      [
        option({ value: Layout.PAGES }, '1 Page / Sheet'),
        option({ value: Layout.SPREADS }, '1 Spread / Sheet'),
        option({ value: Layout.BOOKLET }, 'Booklet Sheets'),
      ].map((opt) => {
        if (parseInt(opt.value, 10) === initialState.layout) { opt.selected = true; }
        return opt;
      })
    );
    const arrangement = row([layoutSelect]);

    marksSelect = dropdown(
      { onchange: e => actions.setMarks(e.target.value) },
      [
        option({ value: Marks.NONE }, 'No Marks'),
        option({ value: Marks.CROP, selected: true }, 'Crop Marks'),
        option({ value: Marks.BLEED }, 'Bleed Marks'),
        option({ value: Marks.BOTH }, 'Crop and Bleed'),
      ].map((opt) => {
        if (opt.value === initialState.marks) { opt.selected = true; }
        return opt;
      })
    );
    if (supportsCustomPageSize) {
      marksSelect.classList.add(c('hidden-select'));
    }
    const marks = row([marksSelect]);
    const sheetSize = row([sheetSizeSelect]);


    this.setDone = () => {};
    this.setInProgress = () => {};
    this.updateProgress = () => {};

    printBtn.classList.add(c('btn-print'));
    const options = row([arrangement, sheetSize, marks]);
    options.classList.add(c('print-options'));

    viewSelect = dropdown(
      { onchange: e => actions.setMode(e.target.value) },
      [
        option({ value: Mode.PREVIEW }, 'Preview'),
        option({ value: Mode.FLIPBOOK }, 'Flipbook'),
        option({ value: Mode.PRINT }, 'Print Preview'),
      ].map((opt) => {
        if (opt.value === initialState.mode) { opt.selected = true; }
        return opt;
      })
    );
    const viewRow = row([viewSelect]);
    viewRow.classList.add(c('view-row'));

    this.element = div(c('controls'), [viewRow, options, printBtn]);
  }

}

return Controls;

})));
//# sourceMappingURL=bindery-controls.umd.js.map
